<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task41.55</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>
    <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        <div class = "container jumbotron">
          <div class="row">
            <label class = "col-sm-2 col-form-label">Trạng thái order</label>
            <div class = "col-sm-3">
                <select id="select-order-status" class = "form-control">
                    <option value="all">(All)</option>
                    <option value="open">Open</option>
                    <option value="confirmed">Confirmed</option>
                    <option value="cancel">Cancel</option>
                </select>
            </div>
            <label class = "col-sm-2 col-form-label">Loại pizza</label>
            <div class = "col-sm-3">
                <select id="select-pizza" class = "form-control">
                    <option value="all">(All)</option>
                    <option value="Hawaii">Hawaii</option>
                    <option value="Bacon">Bacon</option>
                    <option value="Seafood">Seafood</option>
                </select>
            </div>
            <button class="btn btn-info col-sm-2" id="btn-filter-orders">Lọc</button>
          </div>
          
        </div>
        <table class="table table-bordered table-striped table-hover" id="order-table">
          <thead>
            <tr>
              <th>Order Code</th>
              <th>Kích cỡ combo</th>
              <th>Loại pizza</th>
              <th>Nước uống</th>
              <th>Thành tiền</th>
              <th>Họ và tên</th>
              <th>Số điện thoại</th>
              <th>Trạng thái</th>
              <th>Chi tiết</th>
            </tr>
        </table>
      </div>
</body>
<script>
    "use strict";
  $(document).ready(function() {
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    // base url API
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";

    var gOrdersArr =[];
    const gCOLUMN_CODE = 0;
    const gCOLUMN_COMBO = 1;
    const gCOLUMN_PIZZA = 2;
    const gCOLUMN_DRINK = 3;
    const gCOLUMN_AMOUNT = 4 ;
    const gCOLUMN_NAME = 5;
    const gCOLUMN_PHONE = 6;
    const gCOLUMN_ORDER_STATUS = 7;
    const gCOLUMN_DETAIL = 8;

    const gUSER_COL = ["orderCode","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","detail"]
    
    // khởi tạo data table  - chưa có data
    var gOrderTable = $("#order-table").DataTable( {
      // Khai báo các cột của datatable
      "columns" : [
          { "data" : gUSER_COL[gCOLUMN_CODE] },
          { "data" : gUSER_COL[gCOLUMN_COMBO] },
          { "data" : gUSER_COL[gCOLUMN_PIZZA] },
          { "data" : gUSER_COL[gCOLUMN_DRINK] },
          { "data" : gUSER_COL[gCOLUMN_AMOUNT] },
          { "data" : gUSER_COL[gCOLUMN_NAME] },
          { "data" : gUSER_COL[gCOLUMN_PHONE] },
          { "data" : gUSER_COL[gCOLUMN_ORDER_STATUS] },
          { "data" : gUSER_COL[gCOLUMN_DETAIL] }
      ],
      // Ghi đè nội dung của cột action, chuyển thành button chi tiết
      "columnDefs": [ 
      {
          "targets": gCOLUMN_DETAIL,
          "defaultContent": "<button class='info-order btn btn-info'>Chi tiết</button>"
      }]
    });
    
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    onPageLoading();
    //gán sự kiện cho nút filter
    $("#btn-filter-orders").click(function(){
      onBtnFilterOrderClick();
    })
    // gán click event handler cho button chi tiet
    $("#order-table").on("click", ".info-order", function() {
      onButtonChiTietClick(this); // this là button được ấn
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */  
    // hàm chạy khi trang được load
    function onPageLoading() {
      // lấy data từ server
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        dataType: 'json',
        success: function(responseObject){
          //debugger;
          gOrdersArr = responseObject;
          loadDataToTable(responseObject);
        },
        error: function(error){
          console.assert(error.responseText);
        }
      });
    }
    //hàm xử lý nút sự kiện filter click
    function onBtnFilterOrderClick(){
      var vFilterObj = {
        trangThai:"",
        loaiPizza: ""
      };
      //b1: thu thập dữ liệu
      thuThapDuLieuFilter(vFilterObj);
      //b2: validate(không có)
      //b3: filter order
      var vOrdersResult = filterOrders(vFilterObj);

      //b4: hiển thị dữ liệu sau khi lọc
      loadDataToTable(vOrdersResult);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
    // load data to table
    function loadDataToTable(paramResponseObject) {
      //Xóa toàn bộ dữ liệu đang có của bảng
      gOrderTable.clear();
      //Cập nhật data cho bảng 
      gOrderTable.rows.add(paramResponseObject);
      //Cập nhật lại giao diện hiển thị bảng
      gOrderTable.draw();
    }
    //đọc thông tin dùng để lọc
    function thuThapDuLieuFilter(paramFilterObj){
      paramFilterObj.trangThai = $("#select-order-status").val();
      paramFilterObj.loaiPizza = $("#select-pizza").val();
    }
    //hàm lọc theo Filter Object
    function filterOrders(paramFilterObj){
      var vOrders = [];
      vOrders = gOrdersArr.filter(function(paramOrder){
        return ((paramOrder.trangThai == paramFilterObj.trangThai || paramFilterObj.trangThai == "all") 
        && (paramOrder.loaiPizza == paramFilterObj.loaiPizza|| paramFilterObj.loaiPizza == "all"));
      });
      return vOrders;
    }
});
</script>
</html>